OpenVDB: BaseStencil< DerivedType, SIZE, GridT > Class Template Reference

OpenVDB 11.0.0

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
BaseStencil< DerivedType, SIZE, GridT > Class Template Reference

`#include <nanovdb/util/Stencils.h>`

## Classes
struct | Mask

## Public Types
using | ValueType = typename GridT::ValueType
using | GridType = GridT
using | TreeType = typename GridT::TreeType
using | AccessorType = typename GridT::AccessorType

## Public Member Functions
__hostdev__ void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
__hostdev__ void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.
template<typename IterType >
__hostdev__ void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
template<typename RealType >
__hostdev__ void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
__hostdev__ const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
template<int i, int j, int k>
__hostdev__ const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil.
template<int i, int j, int k>
__hostdev__ void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
__hostdev__ ValueType | mean () const
| Return the mean value of the current stencil.
__hostdev__ ValueType | min () const
| Return the smallest value in the stencil buffer.
__hostdev__ ValueType | max () const
| Return the largest value in the stencil buffer.
__hostdev__ const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
__hostdev__ const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
__hostdev__ bool | intersects (const ValueType &isoValue=ValueType(0)) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ Mask | intersectionMask (ValueType isoValue=ValueType(0)) const
| Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
__hostdev__ const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
__hostdev__ const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Member Functions
static __hostdev__ int | size ()
| Return the size of the stencil buffer.

## Protected Member Functions
__hostdev__ | BaseStencil (const GridType &grid)

## Protected Attributes
const GridType * | mGrid
AccessorType | mAcc
ValueType | mValues [SIZE]
Coord | mCenter

## Member Typedef Documentation

## ◆ AccessorType

template<typename DerivedType , int SIZE, typename GridT >

using AccessorType = typename GridT::AccessorType

## ◆ GridType

template<typename DerivedType , int SIZE, typename GridT >

using GridType = GridT

## ◆ TreeType

template<typename DerivedType , int SIZE, typename GridT >

using TreeType = typename GridT::TreeType

## ◆ ValueType

template<typename DerivedType , int SIZE, typename GridT >

using ValueType = typename GridT::ValueType

## Constructor & Destructor Documentation

## ◆ BaseStencil()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ BaseStencil | ( | const GridType & | grid | ) |
| inlineprotected

## Member Function Documentation

## ◆ accessor()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ const AccessorType & accessor | ( |  | ) | const
| inline

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ getCenterCoord()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ const Coord & getCenterCoord | ( |  | ) | const
| inline

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ const ValueType & getCenterValue | ( |  | ) | const
| inline

Return the value at the center of the stencil.

## ◆ getValue() [1/2]

template<typename DerivedType , int SIZE, typename GridT >
template<int i, int j, int k>

__hostdev__ const ValueType & getValue | ( |  | ) | const
| inline

Return the value at the specified location relative to the center of the stencil.

## ◆ getValue() [2/2]

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ const ValueType & getValue | ( | unsigned int | pos = `0` | ) | const
| inline

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ grid()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ const GridType & grid | ( |  | ) | const
| inline

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersectionMask()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ Mask intersectionMask | ( | ValueType | isoValue = `ValueType(0)` | ) | const
| inline

Return true a bit-mask where the 6 lower bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use (mask & (1u<<2)) where mask is ther return value from this function. To check if there are any intersections use mask!=0u, and for no intersections use mask==0u. To count the number of intersections use __builtin_popcount(mask).

## ◆ intersects()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ bool intersects | ( | const ValueType & | isoValue = `ValueType(0)` | ) | const
| inline

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ max()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ ValueType max | ( |  | ) | const
| inline

Return the largest value in the stencil buffer.

## ◆ mean()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ ValueType mean | ( |  | ) | const
| inline

Return the mean value of the current stencil.

## ◆ min()

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ ValueType min | ( |  | ) | const
| inline

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ void moveTo | ( | const Coord & | ijk | ) |
| inline

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ moveTo() [2/4]

template<typename DerivedType , int SIZE, typename GridT >

__hostdev__ void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue
| ) |  |
| inline

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stencil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [3/4]

template<typename DerivedType , int SIZE, typename GridT >
template<typename IterType >

__hostdev__ void moveTo | ( | const IterType & | iter | ) |
| inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## ◆ moveTo() [4/4]

template<typename DerivedType , int SIZE, typename GridT >
template<typename RealType >

__hostdev__ void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inline

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ setValue()

template<typename DerivedType , int SIZE, typename GridT >
template<int i, int j, int k>

__hostdev__ void setValue | ( | const ValueType & | value | ) |
| inline

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

template<typename DerivedType , int SIZE, typename GridT >

static __hostdev__ int size | ( |  | ) |
| inlinestatic

Return the size of the stencil buffer.

## Member Data Documentation

## ◆ mAcc

template<typename DerivedType , int SIZE, typename GridT >

AccessorType mAcc
| protected

## ◆ mCenter

template<typename DerivedType , int SIZE, typename GridT >

Coord mCenter
| protected

## ◆ mGrid

template<typename DerivedType , int SIZE, typename GridT >

const GridType* mGrid
| protected

## ◆ mValues

template<typename DerivedType , int SIZE, typename GridT >

ValueType mValues[SIZE]
| protected